import $config from "@/config/global.config.js"
// 此vm参数为页面的实例，可以通过它引用vuex中的变量
export const Request = (vm) => {
	// 初始化请求配置
	uni.$uv.http.setConfig((config) => {
		/* config 为默认全局配置*/
		config.baseURL = $config.baseUrl; /* 根域名 */
		return config
	})

	// 请求拦截
	uni.$uv.http.interceptors.request.use((config) => { // 可使用async await 做异步操作
		// 初始化请求拦截器时，会执行此方法，此时data为undefined，赋予默认{}
		config.data = config.data || {}
		// 根据custom参数中配置的是否需要token，添加对应的请求头
		// if (config?.custom?.auth) {
		// 可以在此通过vm引用vuex中的变量，具体值在vm.$store.state中
		// config.header.apiToken = vm.$store.state.userInfo.token
		config.header.apiToken = uni.getStorageSync('apiToken');
		// }
		return config
	}, config => { // 可使用async await 做异步操作
		return Promise.reject(config)
	})

	// 响应拦截
	uni.$uv.http.interceptors.response.use((response) => { /* 对响应成功做点什么 可使用async await 做异步操作*/
		const data = response.data
		// 自定义参数
		const custom = response.config?.custom
		if (data.code !== 200) {
			// 如果没有显式定义custom的toast参数为false的话，默认对报错进行toast弹出提示
			// 100001为小程序登录接口判断是否注册时报错
			if (custom.toast !== false && data.code != 100001 && data.code != 100011) {
				try {
					uni.hideLoading();
				} catch (error) {
				}
				uni.$uv.toast(data.message || data.msg || '');
			}
			let codeList = [401, 50000, 100004, 100005, 100001, 100003, 100002];
			if (codeList.includes(data.code)) {
				// uni.removeStorageSync('apiToken');
				if ((data.code == 100003 || data.code == 100002) && !uni.getStorageSync('apiToken')) return;
				uni.clearStorageSync();
				// 判断微信小程序环境执行
				// #ifdef MP-WEIXIN
				uni.navigateTo({
					url: '/pages/login/wxLogin'
				})
				// #endif
				// 判断非微信小程序环境执行
				// #ifndef MP-WEIXIN
				uni.navigateTo({
					url: '/pages/login/otherLogin'
				})
				// #endif
			}
			return Promise.reject(data)
			// 如果需要catch返回，则进行reject
			// if (custom?.catch) {
			// 	return Promise.reject(data)
			// } else {
			// 	// 否则返回一个pending中的promise，请求不会进入catch中
			// 	return new Promise(() => { })
			// }
		}
		return data === undefined ? {} : data
	}, (response) => {
		// 对响应错误做点什么 （statusCode !== 200）
		return Promise.reject(response)
	})
}